"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Matomo = void 0;
const utils_1 = require("../../../utils");
const MatomoTracker = require('matomo-tracker');
class Matomo {
    constructor(config) {
        this.config = config;
        this._userId = '';
        this._payload = {
            ua: 'Creately:Siddi',
        };
        this.trackingClient = new MatomoTracker(this.config.MATOMO_SITE_ID, this.config.MATOMO_SITE_URL, true);
        this.trackingClient.on('error', (err) => {
            (0, utils_1.LOG_MSG)('Error in Tracking Event', 'MatomoTracker');
            (0, utils_1.LOG_MSG)(JSON.stringify(err, null, 2), 'MatomoTracker');
        });
    }
    identify(userId, userProperties) {
        this._payload = Object.assign(Object.assign(Object.assign({}, this._payload), { uid: userId }), userProperties);
        this._userId = userId;
    }
    sendEvent(eventName, eventProperties, userId) {
        return __awaiter(this, void 0, void 0, function* () {
            const data = {
                action_name: eventName,
                uid: this._userId || userId,
                url: this.config.MATOMO_SOURCE_URL || 'https://siddi.creately.com/?event=' + eventName,
                e_a: eventProperties.eventAction || 'unknown',
                e_c: eventProperties.eventCategory || 'unspecified',
                e_n: eventName,
            };
            this.trackingClient.track(Object.assign(Object.assign({}, this._payload), data));
        });
    }
}
exports.Matomo = Matomo;
//# sourceMappingURL=matomo.js.map